Imports System.Runtime.InteropServices

Public Class NativeMethods

    Delegate Sub FTWRITEDATACALLBACK(ByVal lpParam As IntPtr, ByVal lpData As IntPtr, ByVal nLen As Int32)

    '======================================================================================='
    '                                Video Codec Enumeration                                '
    '======================================================================================='
    Public Const FT_VIDEOCODEC_SCREENVIDEO As Integer = &H3

    '======================================================================================='
    '                                Audio Codec Enumeration                                '
    '======================================================================================='
    Public Const FT_SOUNDFORMAT_UNCOMPRESSED As Integer = &H0

    Public Const FT_SOUNDRATE_5KHZ As Integer = &H0
    Public Const FT_SOUNDRATE_11KHZ As Integer = &H1
    Public Const FT_SOUNDRATE_22KHZ As Integer = &H2
    Public Const FT_SOUNDRATE_44KHZ As Integer = &H3

    Public Const FT_SOUNDSIZE_8BIT As Integer = &H0
    Public Const FT_SOUNDSIZE_16BIT As Integer = &H1

    Public Const FT_SOUNDTYPE_MONO As Integer = &H0
    Public Const FT_SOUNDTYPE_STEREO As Integer = &H1

    '====================================================================================='
    '                                FTVIDEOINFO structure                                '
    '====================================================================================='
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi)> _
    Public Structure FTVIDEOINFO
        Dim dwCodec As Int32
        Dim dwWidth As Int32
        Dim dwHeight As Int32
    End Structure

    '====================================================================================='
    '                                FTAUDIOINFO structure                                '
    '====================================================================================='
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi)> _
    Public Structure FTAUDIOINFO
        Dim dwFormat As Int32
        Dim dwRate As Int32
        Dim dwSize As Int32
        Dim dwType As Int32
    End Structure

    '====================================================================================='
    '                              FTFLVSTREAMINFO structure                              '
    '====================================================================================='
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi)> _
    Public Structure FTFLVSTREAMINFO
        Dim lpVideoInfo As IntPtr
        Dim lpAudioInfo As IntPtr
        <MarshalAs(UnmanagedType.FunctionPtr)> _
        Dim lpWriteDataCallback As FTWRITEDATACALLBACK
        Dim lpParam As IntPtr
    End Structure

    '====================================================================================='
    '                                FLV Stream interface                                 '
    '====================================================================================='
    ' Create FLV stream
    <System.Runtime.InteropServices.DllImport("flashtool.dll")> _
    Public Shared Function ftFlvStreamCreate(ByRef lpFlvStreamInfo As FTFLVSTREAMINFO) As IntPtr
    End Function

    ' Destroy FLV stream
    <System.Runtime.InteropServices.DllImport("flashtool.dll")> _
    Public Shared Sub ftFlvStreamDestroy(ByVal hFlvStream As IntPtr)
    End Sub

    ' Add video tag to FLV stream
    <System.Runtime.InteropServices.DllImport("flashtool.dll")> _
    Public Shared Sub ftFlvStreamPutVideoData(ByVal hFlvStream As IntPtr, ByVal lpData As IntPtr, ByVal nLen As Int32, ByVal nTimeStamp As Int32)
    End Sub

    ' Add audio tag to FLV stream
    <System.Runtime.InteropServices.DllImport("flashtool.dll")> _
    Public Shared Sub ftFlvStreamPutAudioData(ByVal hFlvStream As IntPtr, ByVal lpData As IntPtr, ByVal nLen As Int32, ByVal nTimeStamp As Int32)
    End Sub

    ' Set context secure key
    <System.Runtime.InteropServices.DllImport("flashtool.dll")> _
    Public Shared Sub ftSetContextKey(<MarshalAs(UnmanagedType.LPStr)> ByVal szKey As String)
    End Sub

    '====================================================================================='
    '                            ScreenVideo encoder interface                            '
    '====================================================================================='
    ' Create ScreenVideo encoder
    <System.Runtime.InteropServices.DllImport("flashtool.dll")> _
    Public Shared Function ftScreenVideoEncoderCreate(ByVal dwWidth As Int32, ByVal dwHeight As Int32, ByVal dwBlockSize As Int32) As IntPtr
    End Function

    ' Destroy ScreenVideo encoder
    <System.Runtime.InteropServices.DllImport("flashtool.dll")> _
    Public Shared Sub ftScreenVideoEncoderDestroy(ByVal hScreenVideoEncoder As IntPtr)
    End Sub

    ' Encode row video frame to ScreenVideo frame
    <System.Runtime.InteropServices.DllImport("flashtool.dll")> _
    Public Shared Function ftScreenVideoEncodeFrame(ByVal hScreenVideoEncoder As IntPtr, ByVal lpData As IntPtr, ByVal cbBytes As Int32, ByVal bFlipY As Boolean) As Boolean
    End Function

    ' Get current encoded frame data
    <System.Runtime.InteropServices.DllImport("flashtool.dll")> _
    Public Shared Sub ftScreenVideoGetEncodedFrame(ByVal hScreenVideoEncoder As IntPtr, ByRef lppData As IntPtr, ByRef lpcbBytes As Int32)
    End Sub

End Class
